#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct
{
    char type;
    int width;
} EntryT;

typedef enum {T, W} StatusT;
union
{
    char buf[1024];
    EntryT desc[1024 / sizeof(EntryT)];
} e;

int main(int argc, char *argv[])
{
    FILE *f, *g;
    char buf[1025];
    char name[256]="";
    char *token[512];
    StatusT status;
    int i, j, n;

    f = fopen(argv[1], "r");
    fgets(buf, sizeof(buf), f);
    memset(&e, '\0', sizeof(e));
    memset(token, '\0', sizeof(token));
    strcpy(name, argv[1]);
    strcat(name, ".dbj");
    g = fopen(name, "wb");
    for (i = j = 0, status = T, token[0] = strtok(buf, ",;"); i < 511 && token[i]; token[++i]= strtok(NULL, ";,"))
    {
        if (status == T)
        {
            if (*token[i] == 'C' || *token[i] == 'D' || *token[i] == 'I')
            {
              e.desc[j].type = *token[i];
            }
            else
            {
                fprintf(stderr, "Bad type: [%s]. Stop\n", token[i]);
                exit(1);
            }
            status = W;
        }
        else
        {
            e.desc[j].width = atoi(token[i]);
            if (e.desc[j].width <= 0)
            {
                fprintf(stderr, "Bad width: [%s]. Stop\n", token[i]);
                exit(1);
            }
            status = T;
            j++;
        }
    }
    n = j;
    fwrite(&e, sizeof(e), 1, g); // write header record

    while (fgets(buf, sizeof(buf), f))
    {
        memset(token, '\0', sizeof(token));
        for (i = 0, token[0] = strtok(buf, ",;"); i < n && token[i]; token[++i]= strtok(NULL, ";,"))
        {
          switch (e.desc[i].type)
          {
            case 'I':
            {
              long v = atol(token[i]);
              fwrite(&v, sizeof(long), 1, g);
              break;
            }
            case 'C':
            {
              char *v = (char *)calloc(1, e.desc[i].width + 1);
              memset(v, '\0', e.desc[i].width + 1);
              strncpy(v, token[i], e.desc[i].width);
              fwrite(v, e.desc[i].width + 1, 1, g);
              break;
            }
            case 'D':
            {
              int j;
              long v[2];
              for (j = 0; j < strlen(token[i]); j++)
                 if (token[i][j] == '.')
                 {
                   token[i][j] = '\0';
                   break;
                 }
              v[0] = atol(token[i]) ;
              v[1] = atol(&token[i][j+1]);
              fwrite(v, 2 * sizeof(long), 1, g);
              break;
            }
            default:
              fprintf(stderr, "Bad type %c. Ignored\n", e.desc[i].type);
              break;
          }
        }
    }
    fclose(f);
    fclose(g);
    g = fopen(name, "rb");
    memset(&e, '\0', sizeof(e));
    fread(&e, sizeof(e), 1, g); // read header record
    for (i = 0; i < n; i++)
    {
        printf("%c,%d%c", e.desc[i].type, e.desc[i].width, (i < n - 1)? ',':' ');
    }
    puts("");

    for (; n;)
    {
        for (i = 0; i < n; i++)
        {
          switch (e.desc[i].type)
          {
            case 'I':
            {
              long v;
              if (fread(&v, sizeof(long), 1, g) <= 0)
              {
                  n = 0; // to force exit
                  continue;
              }
              sprintf(buf, "%%%d.%dd", e.desc[i].width, e.desc[i].width);
              printf(buf, v);
              break;
            }
            case 'C':
            {
              char *v = (char *)calloc(1, e.desc[i].width + 1);
              fread(v, e.desc[i].width + 1, 1, g);
              sprintf(buf, "%%-%d.%ds", e.desc[i].width, e.desc[i].width);
              printf(buf, v);
              break;
            }
            case 'D':
            {
              int j = e.desc[i].width / 2;
              long v[2];
              sprintf(buf, "%%%d.%dd.%%-%dd", e.desc[i].width - j, e.desc[i].width - j, j);
              fread(v, 2 * sizeof(long), 1, g);
              printf(buf, v[0], v[1]);
              break;
            }
            default:
              fprintf(stderr, "Bad type %c. Ignored\n", e.desc[i].type);
              break;
          }
          if (i < n - 1) printf(",");
        }
        puts("");
    }
    fclose(g);
    return 0;
}
